--[[

 Windows-like Minesweeper for PSP
 developed by SiGi, 2005

]]




hiscoreFile="hiscore.dat"

OptionsFile="options.dat"


name={27,27,27,27,27,27,27,27,27,27,27,27}



--If you want to edit the graphics, these are all the colors used in the game:

boxcolor = Color.new(192,192,192)   --this is the color of the menu boxes, important to change when creating a new skin
white = Color.new(255, 255, 255)
black = Color.new(0, 0, 0)
grey = Color.new(127,127,127)
red= Color.new(255, 0, 0)
yellow=Color.new(255, 255, 0)
blue=Color.new(0,0,255)
title=Color.new(255,127,31)

position=1





m1 = Image.load("1.png")
m2 = Image.load("2.png")
m3 = Image.load("3.png")
m4 = Image.load("4.png")
m5 = Image.load("5.png")
m6 = Image.load("6.png")
m7 = Image.load("7.png")
m8 = Image.load("8.png")
mFlag = Image.load("flag.png")
mCovered = Image.load("covered.png")
mBlank = Image.load("blank.png") 
mMine = Image.load("mine.png")
mRedmine = Image.load("redmine.png")
mPointer = Image.load("pointer.png")
mWrongmine = Image.load("wrongmine.png")


panel=Image.load("panel.png")

RightPanel=Image.load("rightpanel.png")
MidPanel=Image.load("midpanel.png")
LeftPanel=Image.load("leftpanel.png")



d0 = Image.load("d0.png")
d1 = Image.load("d1.png")
d2 = Image.load("d2.png")
d3 = Image.load("d3.png")
d4 = Image.load("d4.png")
d5 = Image.load("d5.png")
d6 = Image.load("d6.png")
d7 = Image.load("d7.png")
d8 = Image.load("d8.png")
d9 = Image.load("d9.png")


dMinus = Image.load("dminus.png")


mTop = Image.load("top.png")
mTopRight = Image.load("topright.png")
mTopLeft = Image.load("topleft.png")

mBottom = Image.load("bottom.png")
mBottomRight = Image.load("bottomright.png")
mBottomLeft = Image.load("bottomleft.png")

mRight = Image.load("right.png")
mLeft = Image.load("left.png")


GameOver=false
Exit=false
RestartGame=false


rightPressed=false
leftPressed=false
downPressed=false
upPressed=false

crossPressed=false
circlePressed=false
squarePressed=false
startPressed=false
selectPressed=false



PressedTreshold=20
PressedSpeed=3    --the less the faster

rPressedCounter=0
lPressedCounter=0
uPressedCounter=0
dPressedCounter=0




DiffLev=1
MaxDiffLev=4

DiffLevs={}

DiffLevs[1]={}
DiffLevs[1].x=9
DiffLevs[1].y=9
DiffLevs[1].mines=10

DiffLevs[2]={}
DiffLevs[2].x=20
DiffLevs[2].y=10
DiffLevs[2].mines=30

DiffLevs[3]={}
DiffLevs[3].x=29
DiffLevs[3].y=13
DiffLevs[3].mines=75

DiffLevs[4]={}
DiffLevs[4].x=15
DiffLevs[4].y=10
DiffLevs[4].mines=25









Mouse=false

PointerX=1
PointerY=1

OldPointerX=PointerX
OldPointerY=PointerY


OffsX=0
OffsY=56


OffsetX=OffsX-16
OffsetY=OffsY-16


time=0

ClickCounter=0


function SaveOptions()


	file = io.open(OptionsFile, "w")

	if file then
     file:write( PressedTreshold.."\n")
     file:write( PressedSpeed.."\n")
     file:write( DiffLevs[4].x.."\n")
     file:write( DiffLevs[4].y.."\n")
     file:write( DiffLevs[4].mines.."\n")
    
	  file:close()
	end



end
 


function LoadOptions()


	file = io.open(OptionsFile, "r")

	if file then
     PressedTreshold=tonumber(file:read("*line"))
     PressedSpeed=tonumber(file:read("*line"))
     DiffLevs[4].x=tonumber(file:read("*line"))
     DiffLevs[4].y=tonumber(file:read("*line"))
     DiffLevs[4].mines=tonumber(file:read("*line"))
     
	  file:close()
	end



end



function SaveHiscore()


	file = io.open(hiscoreFile, "w")

	if file then
     for i=1,3 do
        for j=1,3 do
           file:write(hiscore[i][j].name.."\n")
           file:write(hiscore[i][j].time.."\n")
        end
     end
	  file:close()
	end



end
 



function LoadHiscore()


file = io.open(hiscoreFile, "r")

	if file then
     for i=1,3 do
        for j=1,3 do
           hiscore[i][j].name=file:read("*line")
           hiscore[i][j].time=tonumber(file:read("*line"))
        end
     end
	  file:close()
	end



end





function ResetHiscore()



hiscore={}

hiscore[1]={}

hiscore[1][1]={}
hiscore[1][1].name="ANONYMOUS"
hiscore[1][1].time=999

hiscore[1][2]={}
hiscore[1][2].name="ANONYMOUS"
hiscore[1][2].time=999

hiscore[1][3]={}
hiscore[1][3].name="ANONYMOUS"
hiscore[1][3].time=999


hiscore[2]={}

hiscore[2][1]={}
hiscore[2][1].name="ANONYMOUS"
hiscore[2][1].time=999

hiscore[2][2]={}
hiscore[2][2].name="ANONYMOUS"
hiscore[2][2].time=999

hiscore[2][3]={}
hiscore[2][3].name="ANONYMOUS"
hiscore[2][3].time=999



hiscore[3]={}

hiscore[3][1]={}
hiscore[3][1].name="ANONYMOUS"
hiscore[3][1].time=999

hiscore[3][2]={}
hiscore[3][2].name="ANONYMOUS"
hiscore[3][2].time=999

hiscore[3][3]={}
hiscore[3][3].name="ANONYMOUS"
hiscore[3][3].time=999

end





function GenerateArrays ()

Mines = {}
Flags = {}
Covered = {}

for i=0,SizeX+1 do
  Mines[i] = {}
  Flags[i] = {}
  Covered[i] = {}
  for j=0,SizeY+1 do

    Mines[i][j] = 0

    Flags[i][j] = 0

    Covered[i][j] = 1   --Everything is covered at start, except for borders

    if i==0 then
      Mines[i][j] = 97  --left border
      Covered[i][j] = 0
    end

    if i==SizeX+1 then
      Mines[i][j] = 93  --right border
      Covered[i][j] = 0
    end



    if j==0  then
      Mines[i][j] = 91   --top border
      Covered[i][j] = 0
         if i==0  then
           Mines[i][j] = 90    --top left border
         end

         if i==SizeX+1  then
           Mines[i][j] = 92    --top right border
         end
        
    end

    if j==SizeY+1  then
      Mines[i][j] = 95   --bottom border
      Covered[i][j] = 0
         if i==0  then
           Mines[i][j] = 96    --bottom left border
         end
         if i==SizeX+1  then
           Mines[i][j] = 94    --bottom right  border
         end
        
    end






  end
end

CoveredRemaining=SizeX*SizeY


OffsetX=    240-(SizeX*8)-16

OffsetY=OffsY-16






end


function GenerateMinefield ()

math.randomseed(os.time())

finish = 0
math.randomseed(os.time())

while finish < MineCount do
  x = math.random(SizeX)  
  y = math.random(SizeY)

  if Mines[x][y]==0 then
     Mines[x][y]=9
     finish=finish+1
  end
end

FlagsRemaining=MineCount
ClickCounter=0

end





function ComputeMinefield ()

for x=1,SizeX do
  for y=1,SizeY do

  if Mines[x][y]~=9 then  		
    count=0

    if Mines[x-1][y-1]==9 then 
      count=count+1 
       end
    
    if Mines[x][y-1]==9 then 
      count=count+1
      end
    
    if Mines[x+1][y-1]==9 then 
      count=count+1
      end
    
    if Mines[x+1][y]==9 then 
      count=count+1
    end
    
    if Mines[x+1][y+1]==9 then 
      count=count+1
    end
    if Mines[x][y+1]==9 then 
      count=count+1
      end
    
    if Mines[x-1][y+1]==9 then 
      count=count+1
      end

    if Mines[x-1][y]==9 then 
      count=count+1

      end
    Mines[x][y]=count

  end

  end


end

end






function CascadeBlanks(x,y)  

Covered[x][y]=0
CoveredRemaining=CoveredRemaining-1

if Covered[x-1][y-1]==1 and Flags[x-1][y-1]==0 and Mines[x-1][y-1]<9 then  
  if Mines [x-1][y-1]== 0 then 
    CascadeBlanks (x-1,y-1) 
  else
    Covered[x-1][y-1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end
  
if Covered[x-1][y]==1  and Flags[x-1][y]==0 and Mines[x-1][y]<9 then  
  if Mines [x-1][y]== 0 then 
    CascadeBlanks (x-1,y) 
  else
    Covered[x-1][y]=0
    CoveredRemaining=CoveredRemaining-1
  end
end

if Covered[x-1][y+1]==1 and Flags[x-1][y+1]==0 and Mines[x-1][y+1]<9 then  
  if Mines [x-1][y+1]== 0 then 
    CascadeBlanks (x-1,y+1) 
  else
    Covered[x-1][y+1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end

if Covered[x][y+1]==1 and Flags[x][y+1]==0 and Mines[x][y+1]<9 then  
  if Mines [x][y+1]== 0 then 
    CascadeBlanks (x,y+1) 
  else
    Covered[x][y+1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end
   
if Covered[x+1][y+1]==1 and Flags[x+1][y+1]==0 and Mines[x+1][y+1]<9 then  
  if Mines [x+1][y+1]== 0 then 
    CascadeBlanks (x+1,y+1) 
  else
    Covered[x+1][y+1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end
   
if Covered[x+1][y]==1  and Flags[x+1][y]==0 and Mines[x+1][y]<9 then  
  if Mines [x+1][y]== 0 then 
    CascadeBlanks (x+1,y) 
  else
    Covered[x+1][y]=0
    CoveredRemaining=CoveredRemaining-1
  end
end
   
if Covered[x+1][y-1]==1  and Flags[x+1][y-1]==0 and Mines[x+1][y-1]<9 then  
  if Mines [x+1][y-1]== 0 then 
    CascadeBlanks (x+1,y-1) 
  else
    Covered[x+1][y-1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end

if Covered[x][y-1]==1 and Flags[x][y-1]==0 and Mines[x][y-1]<9 then  
  if Mines [x][y-1]== 0 then 
    CascadeBlanks (x,y-1) 
  else
    Covered[x][y-1]=0
    CoveredRemaining=CoveredRemaining-1
  end
end







end




--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************
--********************************************************************


function EnterNewHiscore(place)
  



abc={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"," "," "}


local message="NEW EXCEPTIONAL TIME! PLEASE ENTER YOUR NAME"
local message2="Use arrows to type, START to finish, CIRCLE to clear"



TextWidth=  math.ceil((string.len(message2)*8)/16)+1

local x=240
local y=136
local finish=false

local oldposition=position
local maxlength=12

local i=1
local toggle=0
local index=1

local LetterMax=27
local letter=name[position]



DrawBox (x,y,TextWidth,4)
screen:print (x-(4*string.len(message)),y-16,message,black)
screen:print (x-(4*string.len(message2)),y-4,message2,black)


screen:flip()

DrawBox (x,y,TextWidth,4)
screen:print (x-(4*string.len(message)),y-16,message,black)
screen:print (x-(4*string.len(message2)),y-4,message2,black)


while true do

oldposition=position


pad = Controls.read()


if pad:up() then

	if upPressed==false or uPressedCounter>PressedTreshold   then
		letter=letter+1
      uPressedCounter=uPressedCounter-PressedSpeed
		if letter>LetterMax then
			letter=1
		end

	end
	upPressed=true
   uPressedCounter=uPressedCounter+1

else
	upPressed=false
   uPressedCounter=0
end


if pad:down() then

	if downPressed==false or dPressedCounter>PressedTreshold then
		letter=letter-1
      dPressedCounter=dPressedCounter-PressedSpeed
		if letter<1 then
			letter=LetterMax
		end
	end
	downPressed=true
   dPressedCounter=dPressedCounter+1

else
	downPressed=false
   dPressedCounter=0
end



if pad:right()  then 
  if rightPressed==false then
    rightPressed=true
    position=position+1
    if position>maxlength then position=maxlength  end
    letter=name[position]
   end
else
    rightPressed=false
end



if pad:left()  then 
  if leftPressed==false then
    leftPressed=true
    position=position-1
    if position<1 then position=1  end
    letter=name[position]
   end
else
    leftPressed=false
end




if pad:circle() then 
  if circlePressed==false then
     circlePressed=true
     name={27,27,27,27,27,27,27,27,27,27,27,27}
     letter=27
     position=1
     screen:fillRect (x-1-(4*maxlength),y+9, 96,9,boxcolor)
     screen:flip()
     screen:fillRect (x-1-(4*maxlength),y+9, 96,9,boxcolor)
   end
else
    circlePressed=false
end






if pad:start() then 
  if startPressed==false then
    startPressed=true
    finish=true
   end
else
    startPressed=false
end

 
if finish==true then
   break
end




name[position]=letter

screen:fillRect (x-9-(4*maxlength)+(8*oldposition),y+9, 8,9,boxcolor)

for i=1,maxlength do
  index=name[i]
  screen:print (x-8-(4*maxlength)+(8*i),y+10,abc[index],black)
  if i==position then     
     if toggle >10  then 
        screen:print (x-8-(4*maxlength)+(8*i),y+10,abc[index],black)
     else
        screen:fillRect  (x-9-(4*maxlength)+(8*i),y+9,7,9,black)
        screen:print (x-8-(4*maxlength)+(8*i),y+10,abc[index],white)
      end
  end
end


toggle=toggle+1
if toggle>20 then toggle=0 end


screen:flip()


screen:fillRect (x-9-(4*maxlength)+(8*oldposition),y+9, 8,9,boxcolor)
end

WinnersName=""

for i=1,maxlength do
     WinnersName=WinnersName .. abc[name[i]]
end



NewScore={}

NewScore.name=WinnersName
NewScore.time=time

table.insert(hiscore[DiffLev],place,NewScore)



table.remove (hiscore[DiffLev])


DisplayHiscore(place)


end


--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************
--***************************************************************************

function DisplayHelp ()


local x=240
local y=136


local text={
  "Press to uncover a square under  the pointer",
  "Press in menu to execute selection" ,
   "(only where applicable)",
  "",
  "Press to set/unset a flag",
  "",
  "Press on a number to uncover all covered", 
  "adjacent squares, number of flags on adjacent", 
  "squares must be equal to that number",
  "",
  "Press to enter main menu, when in menu,",
  "press to exit that menu"
}

local labels={
  "CROSS:",
  "",
  "",
  "",
  "CIRCLE:",
  "",
  "SQUARE:",
  "",
  "",
  "",
  "START:",
  "",
}



DrawBox (x,y,27,11)

local items=12




for i=1,items do
  screen:print (x-210,y-80+10*i,labels[i],red)
  screen:print (x-150,y-80+10*i,text[i],black)
end

screen.flip()

while true do

pad=Controls.read()

if pad:start() then 
  if startPressed==false then
    startPressed=true
    break
   end
else
    startPressed=false
end


if pad:cross() then 
  if crossPressed==false then
    crossPressed=true
    break
   end
else
    crossPressed=false
end



end




end






function DisplayHiscore(place)


local x=240
local y=136
local i=1
local j=1
local shift=46
local timeshift=86
local multiline=60
local color=black

LevelsString={"BEGINNER","INTERMEDIATE","ADVANCED"}




DrawBox (x,y,16,15)
screen:flip()
DrawBox (x,y,16,15)

local title1="BEST TIMES"
local title2="press X or START to continue"
local title3="press O to reset hiscores"






while true do


screen:print (x-4*string.len(title1),y-110,title1,title)
screen:print (x-4*string.len(title2),y-96,title2,grey)
screen:print (x-4*string.len(title3),y-86,title3,grey)



for i=1, 3 do
     screen:print (x-110,y-60+multiline*(i-1),LevelsString[i],blue)
     for j=1, 3 do
         if (i==DiffLev) and (j==place) then 
           color=red
         else
           color=black
         end
       
       screen:print(x-110,y-shift+multiline*(i-1)+12*(j-1),hiscore[i][j].name,color)
         if hiscore[i][j].time>100 then  
           screen:print(x+timeshift,y-shift+multiline*(i-1)+12*(j-1),hiscore[i][j].time,color)
         else
           if hiscore[i][j].time<10 then
               screen:print(x+timeshift+16,y-shift+multiline*(i-1)+12*(j-1),hiscore[i][j].time,color)
           else
               screen:print(x+timeshift+8,y-shift+multiline*(i-1)+12*(j-1),hiscore[i][j].time,color)
           end
         end
     end
end

pad=Controls.read()

if pad:start() then 
  if startPressed==false then
    startPressed=true
    break
   end
else
    startPressed=false
end


if pad:cross() then 
  if crossPressed==false then
    crossPressed=true
    break
   end
else
    crossPressed=false
end


if pad:circle() then 
  if circlePressed==false then
    circlePressed=true
     if YesNoBox(240,136,"Do you really want to reset hiscores?") then 
        ResetHiscore()
     end
     DrawBox (x,y,16,15)
     screen:flip()
     DrawBox (x,y,16,15)


   end
else
    circlePressed=false
end



screen:flip()
screen.waitVblankStart()






end




end








function Win()

  GameOver=True

  NewHiscore=0

  if DiffLev<4 then
     for  i=3,1,-1 do
        if hiscore[DiffLev][i].time>time then NewHiscore=i end
     end
  end

 


  if NewHiscore==0 then
     MsgBox (240,136,"YOU ARE A WINNER!")
     screen:flip()
     MsgBox (240,136,"YOU ARE A WINNER!")
     WaitForCross()
  else
     EnterNewHiscore(NewHiscore)
  end
   
   --DEBUG CODE
  RestartGame()


end



function WaitForCross()

while true do


pad=Controls.read()

if pad:start() then 
  if startPressed==false then
    startPressed=true
    break
   end
else
    startPressed=false
end


if pad:cross() then 
  if crossPressed==false then
    crossPressed=true
    break
   end
else
    crossPressed=false
end


end


end





function ExchangeMine(x,y)

for i=1,SizeX do
  for j=1,SizeY do
    if Mines[i][j]~=9 then
      if i~=x or j~=y then
        tempx=i
        tempy=j
        i=SizeX
        j=SizeY
      end
    end
  end
end

Mines[x][y]=0
Mines[tempx][tempy]=9


ComputeMinefield ()
Uncover(x,y)



end




function Uncover (x,y)

if Covered[x][y]==1 and Flags[x][y]==0 then 
 if Mines[x][y]==0 then 
    CascadeBlanks(x,y)
    RedrawMinefield ()
    DrawPointer()
    screen.flip()
    RedrawMinefield ()
    DrawPointer()

  else
    
    if Mines[x][y]==9 then
      if ClickCounter==0 then 
        ExchangeMine(x,y)
      else
        MineHit(x,y)
      end

    else
      Covered[x][y]=0
      CoveredRemaining=CoveredRemaining-1
      DrawMine(x,y) 
      DrawPointer() 
      screen.flip()
      DrawMine(x,y) 
      DrawPointer() 
    end


 end


 ClickCounter=ClickCounter+1
end


end






function NumberClick (x,y)

if Mines[x][y]>0 and Mines[x][y]<9 and Covered[x][y]==0 then

  FlagCounter=0
  if Flags[x-1][y-1]==1 then FlagCounter=FlagCounter+1 end
  if Flags[x][y-1]==1 then FlagCounter=FlagCounter+1 end
  if Flags[x+1][y-1]==1 then FlagCounter=FlagCounter+1 end

  if Flags[x+1][y]==1 then FlagCounter=FlagCounter+1 end

  if Flags[x+1][y+1]==1 then FlagCounter=FlagCounter+1 end
  if Flags[x][y+1]==1 then FlagCounter=FlagCounter+1 end
  if Flags[x-1][y+1]==1 then FlagCounter=FlagCounter+1 end

  if Flags[x-1][y]==1 then FlagCounter=FlagCounter+1 end

  if FlagCounter==Mines[x][y] then

    Uncover(x-1,y-1)
    Uncover(x,y-1)
    Uncover(x+1,y-1)

    Uncover(x+1,y)
    Uncover(x-1,y)

    Uncover(x-1,y+1)
    Uncover(x,y+1)
    Uncover(x+1,y+1)

  end

end





end








function DrawPointer() 

screen:blit(PointerX*16+OffsetX, PointerY*16+OffsetY, mPointer) 

end




function DisplayDigit (x,y,n)

   if n==0 then screen:blit(x,y,d0) end
   if n==1 then screen:blit(x,y,d1) end
   if n==2 then screen:blit(x,y,d2) end
   if n==3 then screen:blit(x,y,d3) end
   if n==4 then screen:blit(x,y,d4) end
   if n==5 then screen:blit(x,y,d5) end
   if n==6 then screen:blit(x,y,d6) end
   if n==7 then screen:blit(x,y,d7) end
   if n==8 then screen:blit(x,y,d8) end
   if n==9 then screen:blit(x,y,d9) end
   

end


function DisplayNumber (x,y,n)

   if n<0 then
      screen:blit(x,y,dMinus)
   else
        DisplayDigit (x,y,math.mod (math.floor(n/100),10))
   end

   n=math.abs(n)

   n=math.mod (n,1000)

   DisplayDigit (x+26,y,math.mod (n,10))

   n=math.floor (n/10)

   DisplayDigit (x+13,y,math.mod (n,10))

   n=math.floor (n/10)



end







function DrawMine(x,y)

    if Covered[x][y]==1 then
      if Flags[x][y]==1 then  
        screen:blit(x*16+OffsetX, y*16+OffsetY, mFlag)
      else
        screen:blit(x*16+OffsetX, y*16+OffsetY, mCovered)
      end

    else
      if Mines[x][y]==0 then screen:blit(x*16+OffsetX, y*16+OffsetY, mBlank) end
  
      if Mines[x][y]==1 then screen:blit(x*16+OffsetX, y*16+OffsetY, m1) end

      if Mines[x][y]==2 then screen:blit(x*16+OffsetX, y*16+OffsetY, m2) end

      if Mines[x][y]==3 then screen:blit(x*16+OffsetX, y*16+OffsetY, m3) end

      if Mines[x][y]==4 then screen:blit(x*16+OffsetX, y*16+OffsetY, m4) end

      if Mines[x][y]==5 then screen:blit(x*16+OffsetX, y*16+OffsetY, m5) end

      if Mines[x][y]==6 then screen:blit(x*16+OffsetX, y*16+OffsetY, m6) end

      if Mines[x][y]==7 then screen:blit(x*16+OffsetX, y*16+OffsetY, m7) end

      if Mines[x][y]==8 then screen:blit(x*16+OffsetX, y*16+OffsetY, m8) end

      if Mines[x][y]==9 then screen:blit(x*16+OffsetX, y*16+OffsetY, mMine) end

      if Mines[x][y]==10 then screen:blit(x*16+OffsetX, y*16+OffsetY, mRedmine) end

      if Mines[x][y]==11 then screen:blit(x*16+OffsetX, y*16+OffsetY, mWrongmine) end


      if Mines[x][y]==90 then screen:blit(x*16+OffsetX+8, y*16+OffsetY+8, mTopLeft) end

      if Mines[x][y]==91 then screen:blit(x*16+OffsetX, y*16+OffsetY+8, mTop) end

      if Mines[x][y]==92 then screen:blit(x*16+OffsetX, y*16+OffsetY+8, mTopRight) end

      if Mines[x][y]==93 then screen:blit(x*16+OffsetX, y*16+OffsetY, mRight) end

      if Mines[x][y]==94 then screen:blit(x*16+OffsetX, y*16+OffsetY, mBottomRight) end

      if Mines[x][y]==95 then screen:blit(x*16+OffsetX, y*16+OffsetY, mBottom) end

      if Mines[x][y]==96 then screen:blit(x*16+OffsetX+8, y*16+OffsetY, mBottomLeft) end

      if Mines[x][y]==97 then screen:blit(x*16+OffsetX+8, y*16+OffsetY, mLeft) end

    end


end


function ToggleFlag (x,y)

if Covered[x][y]==1 then
  if Flags[x][y]==1 then 
    Flags[x][y]=0
    FlagsRemaining=FlagsRemaining+1
  else 
    Flags[x][y]=1
    FlagsRemaining=FlagsRemaining-1
  end
end

DrawMine(x,y) 
DrawPointer() 
screen.flip()
DrawMine(x,y) 
DrawPointer() 


end


function RedrawMinefield ()

for x=0,SizeX+1 do
  for y=0,SizeY+1 do
    DrawMine(x,y)

  end

end



end





function MineHit(x,y)

GameOver=True

Mines[x][y]=10

for x=1 ,SizeX do
   for y=1 ,SizeY do
      Covered [x][y]=0
      if Flags[x][y]==1 and Mines[x][y]<9 then
         Mines[x][y]=11
      end   
   end
end

RedrawMinefield ()


MsgBox (240,136," YOU LOST! ")
--screen:print(204, 20, "GAME OVER", black)

screen:flip()


RedrawMinefield ()

MsgBox (240,136," YOU LOST! ")
--screen:print(204, 20, "GAME OVER", black)




end



function DrawPanel()
   
   MidPanelWidth=SizeX-7
   screen:blit(176-8*MidPanelWidth,0, LeftPanel) 
   screen:blit(240+8*MidPanelWidth,0, RightPanel) 

   if MidPanelWidth>=1 then
     for i=0,MidPanelWidth-1 do
       screen:blit(240+(i*16)-(8*MidPanelWidth),0, MidPanel) 
     end
   end


end



function YesNoBox (x,y,message)

TextWidth=  math.ceil((string.len(message)*8)/16)+1

if TextWidth<8 then TextWidth=8 end

DrawBox (x,y,TextWidth,4)
screen:print (x-(4*string.len(message)),y-16,message,black)


screen:flip()

DrawBox (x,y,TextWidth,4)
screen:print (x-(4*string.len(message)),y-16,message,black)

local result=false

while true do

  if result==false then
      screen:fillRect(x-64, y ,56,12,boxcolor)
      screen:print (x-47, y+2,"YES",black)
      screen:fillRect(x+8, y,56,12,black)
      screen:print (x+30, y+2,"NO",white)
  else
      screen:fillRect(x-64, y ,56,12,black)
      screen:print (x-47, y+2,"YES",white)
      screen:fillRect(x+8, y,56,12,boxcolor)
      screen:print (x+30, y+2,"NO",black)
 end

  pad = Controls.read()

  if pad:left() then 
        if leftPressed==false then    
          leftPressed=true
          result= not result
        end
    else
       leftPressed=false
    end


  if pad:right() then 
        if rightPressed==false then    
          rightPressed=true
          result= not result
        end
    else
       rightPressed=false
    end


  if pad:cross() then 
        if crossPressed==false then    
          crossPressed=true
          break
        end
    else
       crossPressed=false
    end


screen.flip()

end


RedrawAll()

screen.flip()

RedrawAll()



return result

end









function MsgBox (x,y,message)

TextWidth=  math.ceil((string.len(message)*8)/16)+1

DrawBox (x,y,TextWidth,2)

screen:print (x-(4*string.len(message)),y-4,message,black)



end




function DrawBox (x,y,w,h)

screen:fillRect (x-(8*w),y-(8*h),w*16,h*16,boxcolor)


screen:blit (x-(8*w)-8,y-(8*h)-8,mTopLeft)

screen:blit (x+(8*w),y-(8*h)-8,mTopRight)

screen:blit (x-(8*w)-8,y+(8*h),mBottomLeft)

screen:blit (x+(8*w),y+(8*h),mBottomRight)


if w>0 then
  for i=0,w-1 do
    screen:blit (x-(8*w)+(16*i),y-(8*h)-8,mTop)
    screen:blit (x-(8*w)+(16*i),y+(8*h),mBottom)
  end
end


if h>0 then
  for i=0,h-1 do
    screen:blit (x-(8*w)-8,y-(8*h)+(16*i),mLeft)
    screen:blit (x+(8*w),y-(8*h)+(16*i),mRight)
  end
end



end


function MainMenuLoop()

MainMenu={"NEW GAME","OPTIONS","HIGH SCORES","HELP","EXIT GAME"}
MainMenuItems=5
MainMenuItem=1
MainMenuX=104
MainMenuY=90
ExitMainMenu=false


DrawBox (240,136,10,6)


screen.flip()

DrawBox (240,136,10,6)


--8*4 (chars)  +4*3 (gaps)  + 2*8 (borders)


while true do

  pad = Controls.read()

  for i=1,MainMenuItems do

    if MainMenuItem~=i then
      screen:fillRect(188,102-8+12*i,MainMenuX,12,boxcolor)
      screen:print (240-string.len(MainMenu[i])*4,104-8+12*i,MainMenu[i],black)
    else
      screen:fillRect(188,102-8+12*i,MainMenuX,12,black)
      screen:print (240-string.len(MainMenu[i])*4,104-8+12*i,MainMenu[i],white)
    end

  end




  if pad:start() then 
    if startPressed==false then    
      startPressed=true
      ExitMainMenu=true
     end
  else
      startPressed=false
  end

  if pad:up() then 
    if upPressed==false then    
      upPressed=true
      MainMenuItem=MainMenuItem-1
      if MainMenuItem<1 then MainMenuItem=MainMenuItems end
     end
  else
      upPressed=false
  end

  if pad:down() then 
    if downPressed==false then    
      downPressed=true
      MainMenuItem=MainMenuItem+1
      if MainMenuItem>MainMenuItems then MainMenuItem=1 end
     end
  else
      downPressed=false
  end




  if pad:cross()  then 
    if crossPressed==false then
      crossPressed=true      

      if MainMenuItem==1 then
        ExitMainMenu=true
	RestartGame()
        
      end


      if MainMenuItem==2 then
        OptionsMenuLoop()
        
        DrawBox (240,136,10,6)  --redraw Main Menu after returning from Options menu
        screen.flip()
        DrawBox (240,136,10,6)
        
      end
    
      if MainMenuItem==3 then
        DisplayHiscore()
        
        screen:clear()
        RedrawAll()
        DrawBox (240,136,10,6)  --redraw Main Menu after returning from Options menu
        
        screen.flip()
        screen:clear()
        RedrawAll()
        DrawBox (240,136,10,6)
        
      end
      
      if MainMenuItem==4 then
        DisplayHelp()
        
        screen:clear()
        RedrawAll()
        DrawBox (240,136,10,6)  --redraw Main Menu after returning from Options menu
        
        screen.flip()
        screen:clear()
        RedrawAll()
        DrawBox (240,136,10,6)
        
      end
    
      if MainMenuItem==5 then
        if YesNoBox(240,136,"DO YOU REALLY WANT TO QUIT?")==true then
           ExitMainMenu=true
	        Exit=true
        end
        DrawBox (240,136,10,6)  --redraw Main Menu after returning from Yes/No box
        screen.flip()
        DrawBox (240,136,10,6)
      end
        
     end
  else
      crossPressed=false
  end




  screen.flip()

  screen.waitVblankStart()


  if ExitMainMenu==true then break end

end --while cycle


RedrawAll()

screen.flip()

RedrawAll()


end


--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************
--****************************************************************************


function OptionsMenuLoop()


OptionsMenu={}


OptionsMenu[1]={}
OptionsMenu[1]={"BEGINNER","INTERMEDIATE","ADVANCED","CUSTOM"}
OptionsMenu[1].label="GAME DIFFICULTY: "
OptionsMenu[1].type=1                                        --text options type
OptionsMenu[1].greyed=false
OptionsMenu[1].current=DiffLev
OptionsMenu[1].low=1
OptionsMenu[1].high=4


OptionsMenu[2]={}
OptionsMenu[2].label="KEY REPEAT DELAY:"
OptionsMenu[2].type=2                                       --numeric range type
OptionsMenu[2].greyed=false
OptionsMenu[2].current=PressedSpeed
OptionsMenu[2].low=0
OptionsMenu[2].high=5


OptionsMenu[3]={}
OptionsMenu[3].label="KEY REPEAT TRESHOLD:"
OptionsMenu[3].type=2                                       --numeric range type
OptionsMenu[3].greyed=false
OptionsMenu[3].current=PressedTreshold
OptionsMenu[3].low=5
OptionsMenu[3].high=50


OptionsMenu[4]={}
OptionsMenu[4].label="CUSTOM LEVEL WIDTH:"
OptionsMenu[4].type=2                                       --numeric range type
OptionsMenu[4].current=DiffLevs[4].x
OptionsMenu[4].low=8
OptionsMenu[4].high=29


OptionsMenu[5]={}
OptionsMenu[5].label="CUSTOM LEVEL HEIGTH:"
OptionsMenu[5].type=2                                       --numeric range type
OptionsMenu[5].current=DiffLevs[4].y
OptionsMenu[5].low=3
OptionsMenu[5].high=13


OptionsMenu[6]={}
OptionsMenu[6].label="CUSTOM LEVEL MINE COUNT:"
OptionsMenu[6].type= 2                                      --numeric range type
OptionsMenu[6].current=DiffLevs[4].mines
OptionsMenu[6].low=1
OptionsMenu[6].high=(OptionsMenu[4].current*OptionsMenu[5].current)-5   --we will allow x*y-5 mines in the field



OptionsMenu[7]={}
OptionsMenu[7].label="RESUME DEFAULTS"
OptionsMenu[7].type=3                                       --execute command type
OptionsMenu[7].greyed=false


OptionsMenu[8]={}
OptionsMenu[8].label="EXIT MENU"
OptionsMenu[8].type=3                                       --execute command type
OptionsMenu[8].greyed=false


OptionsMenu.x=21
OptionsMenu.y=8
OptionsMenu.count=8


item=1
ExitMenu=false



textw=320
textb=80
textindent=8
textindent2=216

DrawBox (240,136,OptionsMenu.x,OptionsMenu.y)

screen.flip()

DrawBox (240,136,OptionsMenu.x,OptionsMenu.y)


while true do

  OptionsMenu[6].high=(OptionsMenu[4].current*OptionsMenu[5].current)-5   --we will allow x*y-5 mines in the field
  if OptionsMenu[6].current>OptionsMenu[6].high then 
     OptionsMenu[6].current=OptionsMenu[6].high
  end

  if OptionsMenu[1].current==4 then
    OptionsMenu[4].greyed=false
    OptionsMenu[5].greyed=false
    OptionsMenu[6].greyed=false
  else
    OptionsMenu[4].greyed=true
    OptionsMenu[5].greyed=true
    OptionsMenu[6].greyed=true
  end



  pad = Controls.read()

  for i=1,OptionsMenu.count do
    
    if item~=i then
      screen:fillRect(240-textw/2,textb+12*i,textw,12,boxcolor)
      
      if OptionsMenu[i].greyed==true then
        screen:print (240-(textw/2)+textindent,textb+(12*i)+2,OptionsMenu[i].label,grey)
        screen:print(240-(textw/2)+textindent2,textb+(12*i)+2,OptionsMenu[i].current,grey)
      else
        screen:print (240-(textw/2)+textindent,textb+(12*i)+2,OptionsMenu[i].label,black)
        if OptionsMenu[i].type==1 then
          screen:print(240-(textw/2)+textindent2,textb+(12*i)+2,OptionsMenu[i][OptionsMenu[i].current],red)
        end
        if OptionsMenu[i].type==2 then
          screen:print(240-(textw/2)+textindent2,textb+(12*i)+2,OptionsMenu[i].current,red)
        end
      end
    
    else
      screen:fillRect(240-textw/2,textb+12*i,textw,12,black)
      screen:print (240-(textw/2)+textindent,textb+(12*i)+2,OptionsMenu[i].label,white)
    
      if OptionsMenu[i].type==1 then
        screen:print(240-(textw/2)+textindent2,textb+(12*i)+2,OptionsMenu[i][OptionsMenu[i].current],yellow)
      end
    
      if OptionsMenu[i].type==2 then
        screen:print(240-(textw/2)+textindent2,textb+(12*i)+2,OptionsMenu[i].current,yellow)
      end
    
    end
     
  end


--***********************************



  if pad:up() then 
    if upPressed==false then    
      upPressed=true
      item=item-1
      if item<1 then item=OptionsMenu.count end
      while OptionsMenu[item].greyed==true do
        item=item-1
      end
      if item<1 then item=OptionsMenu.count end
     end
  else
      upPressed=false
  end

  if pad:down() then 
    if downPressed==false then    
      downPressed=true
      item=item+1
      if item>OptionsMenu.count then item=1 end
      while OptionsMenu[item].greyed==true do
        item=item+1
      end
      if item>OptionsMenu.count then item=1 end
     end
  else
      downPressed=false
  end



  if pad:start() then 
    if startPressed==false then    
      startPressed=true
      ExitMenu=true
     end
  else
      startPressed=false
  end



  if OptionsMenu[item].type<3 then
      if pad:right() then 
        if rightPressed==false or rPressedCounter>PressedTreshold then    
          rightPressed=true
          rPressedCounter=rPressedCounter-PressedSpeed
          OptionsMenu[item].current=OptionsMenu[item].current+1
          if OptionsMenu[item].current>OptionsMenu[item].high then OptionsMenu[item].current=OptionsMenu[item].low end
        end
        rightPressed=true
        rPressedCounter=rPressedCounter+1
    else
       rightPressed=false
       rPressedCounter=0
    end
    
     if pad:left() then 
        if leftPressed==false or lPressedCounter>PressedTreshold then    
          leftPressed=true
          lPressedCounter=lPressedCounter-PressedSpeed
          OptionsMenu[item].current=OptionsMenu[item].current-1       
          if OptionsMenu[item].current<OptionsMenu[item].low then OptionsMenu[item].current=OptionsMenu[item].high end
        end
        leftPressed=true
        lPressedCounter=lPressedCounter+1
    else
       leftPressed=false
       lPressedCounter=0
    end
    
  else   --*************************************
      if pad:cross()  then 
        if crossPressed==false then
           crossPressed=true      
            
           if item==8 then
              ExitMenu=true
	        end
            
           if item==7 then
              
              OptionsMenu[1].current=1      -- DiffLev
              OptionsMenu[2].current=3      -- PressedSpeed
              OptionsMenu[3].current=20     --PressedTreshold
              OptionsMenu[4].current=15     --DiffLevs[4].x
              OptionsMenu[5].current=10     --DiffLevs[4].y
              OptionsMenu[6].current=25     --DiffLevs[4].mines
              
              
	        end
            
            
        end
     else
        crossPressed=false
     end
  end




--**********************************

  screen.flip()

  screen.waitVblankStart()

  if ExitMenu==true then break end




end  --end of while cycle





PressedSpeed=OptionsMenu[2].current
PressedTreshold=OptionsMenu[3].current
DiffLevs[4].x=OptionsMenu[4].current
DiffLevs[4].y=OptionsMenu[5].current
DiffLevs[4].mines=OptionsMenu[6].current

if DiffLev~=OptionsMenu[1].current then 
  DiffLev=OptionsMenu[1].current
  RestartGame()
end


RedrawAll()

screen.flip()

RedrawAll()



end












function RedrawAll()

screen:clear()
DrawPanel()
DisplayNumber (176-8*MidPanelWidth+13,13,FlagsRemaining)
DisplayNumber (240+8*MidPanelWidth+10,13,time)

RedrawMinefield ()
DrawPointer() 

end



function RestartGame()

SizeX=DiffLevs[DiffLev].x
SizeY=DiffLevs[DiffLev].y
MineCount=DiffLevs[DiffLev].mines

CoveredRemaining=SizeX*SizeY
FlagsRemaining=MineCount



GenerateArrays ()

GenerateMinefield ()

ComputeMinefield ()

PointerX=1
PointerY=1
OldPointerX=PointerX
OldPointerY=PointerY



RedrawAll()

screen.flip()

RedrawAll()


t0=os.clock()






GameOver=false
Exit=false
time=0

ClickCounter=0

end



--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************
--************************************************************************************************************




ResetHiscore()

LoadHiscore()



LoadOptions()

RestartGame()



while true do
pad = Controls.read()


if GameOver==false then


if pad:up() then

	if upPressed==false or uPressedCounter>PressedTreshold   then
		PointerY=PointerY-1
      uPressedCounter=uPressedCounter-PressedSpeed
		if PointerY<1 then
			PointerY=SizeY
		end

	end
	upPressed=true
   uPressedCounter=uPressedCounter+1

else
	upPressed=false
   uPressedCounter=0
end


if pad:down() then

	if downPressed==false or dPressedCounter>PressedTreshold then
		PointerY=PointerY+1
      dPressedCounter=dPressedCounter-PressedSpeed
		if PointerY>SizeY then
			PointerY=1
		end

	end
	downPressed=true
   dPressedCounter=dPressedCounter+1

else
	downPressed=false
   dPressedCounter=0
end


if pad:left() then

	if leftPressed==false or lPressedCounter>PressedTreshold then
		PointerX=PointerX-1
      lPressedCounter=lPressedCounter-PressedSpeed
		if PointerX<1 then
			PointerX=SizeX
		end

	end
	leftPressed=true
   lPressedCounter=lPressedCounter+1

else
	leftPressed=false
   lPressedCounter=0
end



if pad:right() then

	if rightPressed==false or rPressedCounter>PressedTreshold then
		PointerX=PointerX+1
      rPressedCounter=rPressedCounter-PressedSpeed
		if PointerX>SizeX then
			PointerX=1
		end

	end
	rightPressed=true
   rPressedCounter=rPressedCounter+1

else
	rightPressed=false
   rPressedCounter=0

end



if pad:cross() then 
  if crossPressed==false then
    Uncover(PointerX,PointerY)
    crossPressed=true
   end
else
    crossPressed=false
end


if pad:circle() then 
  if circlePressed==false then
    ToggleFlag (PointerX,PointerY) 
    circlePressed=true
   end
else
    circlePressed=false
end



if pad:square() then 
  if squarePressed==false then
    NumberClick (PointerX,PointerY)
    squarePressed=true
   end
else
    squarePressed=false
end







--RedrawMinefield ()

if Mouse==false then 
  if OldPointerX~=PointerX or OldPointerY~=PointerY then
    DrawMine(OldPointerX,OldPointerY) 
    DrawPointer() 
    screen.flip()
    DrawMine(OldPointerX,OldPointerY) 
    DrawPointer() 

  
end

end



if math.abs(os.clock()-t0)>=1 then
   time=time+1
   t0=os.clock()
end




OldPointerX=PointerX
OldPointerY=PointerY



DisplayNumber (176-8*MidPanelWidth+13,13,FlagsRemaining)

DisplayNumber (240+8*MidPanelWidth+10,13,time)


screen.flip()

DisplayNumber (176-8*MidPanelWidth+13,13,FlagsRemaining)

DisplayNumber (240+8*MidPanelWidth+10,13,time)




screen.waitVblankStart()



end


if CoveredRemaining==MineCount then Win() end



if pad:start() then 
  if startPressed==false then
    startPressed=true
    MainMenuLoop()
   end
else
    startPressed=false
end

	




if Exit==true then
   break
end




end

SaveHiscore()

SaveOptions()


